<?php

/**
 * If a post is saved the plugin searches in the xml file for an element with the same title.
 * If a matching element is found, the data is added zu post meta fields.
 */
function kp_save_post_filter()
{
	if( isset( $_REQUEST[ 'post' ] ) && !empty( $_REQUEST[ 'post' ] ) && $_REQUEST[ 'action' ] == 'edit' )
	{
		$kp_AdminOptions = get_option( KP_PLUGIN_OPTIONS_NAME );

		$post = get_post( intval( $_REQUEST[ 'post' ] ) );
		// Get Post title
		$postTitle = $post -> post_title;
		// Get XML data
		$xmlReader = new KPXMLReader( $kp_AdminOptions[ 'KPPodcastXMLURL' ], KP_CACHE_DIR, $kp_AdminOptions[ 'KPCacheXML' ] );
		$items = $xmlReader -> getElements();
		if( $items )
		{
			foreach( $items AS $title => $link )
			{
				if( $title == $postTitle )
				{
					update_post_meta($post->ID, 'KP_MP3_TITLE', $title );
					update_post_meta($post->ID, 'KP_MP3_URL', $link );
				}
			}
		}
	}

}
add_action( 'admin_menu', 'kp_save_post_filter' );

/**
 * Shows Krhennest Content after a post (via HTML template or custom post meta fields)
 */
function kp_read_post( $post )
{
	$kp_AdminOptions = get_option( KP_PLUGIN_OPTIONS_NAME );

	$kpTitle = get_post_meta( $post->ID, 'KP_MP3_TITLE', true );
	$kpMP3Url = get_post_meta( $post->ID, 'KP_MP3_URL', true );
	if( !empty( $kpTitle ) && !empty( $kpMP3Url ) )
	{
		if( $kp_AdminOptions[ 'KPUseCustomFields' ] == 'true' )
		{
			$post -> post_content .= stripslashes( str_replace( array( '%%title%%', '%%link%%' ), array( $kpTitle, $kpMP3Url ), $kp_AdminOptions[ 'KPHtmlTemplate' ] ) );
		}
		else
		{
			$post -> post_content .= "\n<style type=\"text/css\">\n" . $kp_AdminOptions[ 'KPCustomFieldCSS' ] . "\n</style>\n";
		}
	}
}
add_action( 'the_post', 'kp_read_post' );

?>